/*****************************************************************************
 *- Utility Function Declarations (Non-Exported) ----------------------------*
 *****************************************************************************/

#include <visa.h>

ViStatus hmo_InitAttributes (ViSession vi);
ViStatus hmo_DefaultInstrSetup (ViSession openInstrSession);
ViStatus hmo_CheckStatus (ViSession vi);
ViStatus hmo_CheckStatusTimed (ViSession instrSession);
ViStatus hmo_CheckTimedStatusCallback (ViSession vi);
ViStatus hmo_WaitForOPC (ViSession vi, ViUInt32 maxTime);
ViInt32 hmo_StringIndex(ViString array[], ViChar buff[]); 
ViStatus hmo_readBinaryDataBlock (ViSession instrSession,
                                  /*@out@*/ViChar **outputBuffer, /*@out@*/ViUInt32 *byteCount);
ViStatus hmo_invalidViInt32Range (ViSession instrSession, ViInt32 val, ViInt32 min, ViInt32 max);
ViStatus hmo_invalidViUInt32Range (ViSession instrSession, ViUInt32 val, ViUInt32 min, ViUInt32 max);
ViStatus hmo_invalidViReal64Range (ViSession instrSession, ViReal64 val, ViReal64 min, ViReal64 max);
ViStatus hmo_invalidViBooleanRange (ViSession instrSession, ViBoolean val);
//ViStatus hmo_ReadDataUnknownLength(ViSession instrSession, /*@out@*/ViChar **outBuffer, /*@out@*/ViUInt32 *count);
ViStatus hmo_ParseCatalog(ViChar *buffer, ViInt32 size, ViChar *catalogList, ViInt32 *nbValues);
ViStatus hmo_ParseLimitLineCatalog(ViChar *buffer, ViInt32 size, ViChar *catalogList, ViInt32 *nbValues);
void hmo_SWAP_32(unsigned char *data, long points);
void hmo_SWAP_16(unsigned char *data, long points);
ViStatus hmo_dataReadTrace (ViSession instrSession,
                                 ViString trace, 
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViReal64 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus hmo_dataReadTraceInt (ViSession instrSession,
                                 ViString trace, 
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViUInt16 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus hmo_dataReadTraceIntByte (ViSession instrSession,
                                  ViString trace, 
                                  ViInt32 arrayLength, 
                                  /*@out@*/ViByte _VI_FAR traceData[],
                                  ViPInt32 noofPoints);
ViStatus hmo_dataReadTraceOnly (ViSession instrSession,
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViReal64 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus hmo_dataAsciiReadTrace (ViSession instrSession,
                                 ViInt32 window,
                                 ViString trace, 
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViReal64 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus _VI_FUNC hmo_dataReadTraceIQ (ViSession   instrSession,
                                            ViInt32     bufferSize,
                                            ViPInt32    noofPoints,
                                            /*@out@*/ViReal64 _VI_FAR realPartsI[],
                                            /*@out@*/ViReal64 _VI_FAR imaginaryPartsQ[]);                                 
ViStatus hmo_SetOPCTimeout(ViSession   instrSession, ViInt32 timeout);
ViStatus hmo_GetOPCTimeout(ViSession   instrSession, ViInt32 *timeout);
ViStatus hmo_CheckBeforeRead (ViSession instrSession, ViUInt32 maxTime);
ViStatus hmo_ClearBeforeRead (ViSession instrSession);
ViStatus hmo_WaitForOPCCallback (ViSession io);
ViStatus hmo_GetAttributeRepCapName (ViSession instrSession,
                                ViUInt32 attributeID,
                                ViString repCapNameId,
                                ViInt32 value,
                                ViInt32 bufferSize,
                                ViChar _VI_FAR repCapName[]);
void Convert2Binary(int decimal, char *bin);
int ConvertFromBinary(char *buf, int cbase);
ViInt32 hmo_atoi (ViChar *p2buf);
ViReal64 hmo_atof (ViChar *p2buf);
